<template>
  <!-- Input container -->
  <div :class="`_input-container ${fluid ? 'w-full' : ''}`">
    <!-- Slot: label -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="`_input-label ${labelClass}`"
      >
        <label :for="name">{{ label }}</label>
        <span v-if="required"> *</span>
        <span class="py-1 px-2 ml-2 font-semibold rounded bg-@dark-black-rock">{{ vModel ? vModel.length : '0' }}/{{ maxFiles }}</span>
      </div>
    </slot>

    <t-alert
      v-if="isMax"
      show
      :variant="$app.ui.isTheme({
        'light': 'error',
        'dark': 'mirage-error'
      })"
      :dismissible="false"
    >
      <div class="flex gap-2 items-center">
        <v-icon name="exclamation-triangle" />
        <div>
          <i18n
            path="global.limitFiles"
            tag="p"
          >
            <!-- ref {0} -->
            {{ maxFiles }}
          </i18n>
        </div>
      </div>
    </t-alert>

    <!-- Slot: input -->
    <slot name="input">
      <div :class="`_input mb-2 ${inputClass} ${fluid ? 'w-full' : ''}`">
        <!-- Button -->
        <Button
          :variant="variant"
          inline
          @click.native="handlerButtonClick"
        >
          <v-icon
            name="camera"
            class="mr-2"
          />
          {{ $t('global.importPictures') | capitalize }}
        </Button>

        <!-- Uploaded file name & preview -->
        <div
          v-if="vModel && vModel.length"
          class="mt-4"
        >
          {{ $t('global.preview') | capitalize }}
        </div>

        <div
          v-if="vModel && vModel.length"
          class="flex gap-2 items-start mt-2"
        >
          <div
            v-for="(file, index) in vModel"
            :key="file"
            class="block py-1 px-2 min-w-max rounded bg-@dark-black-rock"
          >
            <div class="flex justify-end">
              <v-icon
                class="mt-1 cursor-pointer hover:text-@dark-error"
                name="times-circle"
                @click="deleteImage(index)"
              />
            </div>

            <a
              class="block overflow-hidden w-24"
              target="_blank"
              :href="`${getUrl(file)}`"
            >
              <img
                v-if="getUrl(file)"
                class="mt-2"
                height="64"
                width="100%"
                :src="getUrl(file)"
              >
              <div class="mt-1 whitespace-nowrap">{{ file.name }}</div>
            </a>
          </div>
        </div>

        <!-- Hidden input -->
        <input
          :ref="inputRef"
          class="hidden"
          type="file"
          :name="name"
          placeholder="Choose a file or drop it here..."
          drop-placeholder="Drop file here..."
          multiple
          @change="updateFile"
        >
      </div>
    </slot>

    <!-- Slot: description -->
    <slot name="description">
      <!-- Description -->
      <div
        v-if="description.length > 0"
        :class="`_input-description ${descriptionClass} ${fluid ? 'w-full' : ''}`"
      >
        <p>{{ description }}</p>
      </div>
    </slot>

    <!-- Slot: error -->
    <slot name="error">
      <!-- Error message -->
      <div
        v-if="error.length > 0"
        :class="`_input-error ${errorClass} ${fluid ? 'w-full' : ''}`"
      >
        <p>{{ error }}</p>
      </div>
    </slot>
  </div>
</template>

<script>
import BaseInput from './BaseInput'
/**
 * InputFile component
 */
export default {
  name: 'InputFileMultiple',
  extends: BaseInput,
  props: {
    /**
     * Override 'value' prop
     * See -> ./BaseInput.vue
     */
    value: {
      type: File, // Because input value is null or File
      default: null
    },
    maxFiles: {
      type: Number,
      default: 6,
      required: true
    }
  },
  data () {
    return {
      isMax: false
    }
  },
  methods: {
    deleteImage (index) {
      const fileListArr = Array.from(this.vModel)
      fileListArr.splice(index, 1)
      this.vModel = fileListArr
    },
    getUrl: function (file) {
      return URL.createObjectURL(file)
    },
    /**
     * Update input value with first file
     * @return {void}
     */
    updateFile: function () {
      if (this.maxFiles && (this.$refs[this.inputRef].files.length > this.maxFiles)) {
        this.isMax = true
      } else {
        this.isMax = false
        this.vModel = this.$refs[this.inputRef].files
      }
    },
    /**
     * Handle click on input button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handlerButtonClick (evt) {
      evt.preventDefault()
      // Simulate click on hidden input
      this.$refs[this.inputRef].click()
    }
  }
}
</script>

<style lang="scss">
// do
</style>
